varying vec2 UV;
uniform sampler2D textureSampler;
uniform sampler2D depthSampler;
uniform vec2 screenSize;
const float zNear = 0.01f;
const float zFar = 500.f;

// http://stackoverflow.com/a/6657284/214063
float linearize(float z_b) {
    float z_n = 2.0 * z_b - 1.0;
    float z_e = 2.0 * zNear * zFar / (zFar + zNear - z_n * (zFar - zNear));
    return z_e;
}

void main() {
    vec2 pixel = (UV * screenSize);

    vec4 color = (texture2D(textureSampler, pixel / screenSize));
    float depth = linearize(texture2D(depthSampler, pixel / screenSize).x);

    color = mix(color, vec4(0.05, 0.2, 0.4, 1), clamp((depth - 10) / 20.0f, 0, 0.5));

    // Invert colors
    gl_FragColor = color;
}